import DatatableColumnData from './datatable-columns-data';
import DatatableOrderFixed from './datatable-order-fixed';
import DatatableConfiguration from './datatable-configuration';

export default class DatatableColumnsSettings
  implements DataTables.ColumnSettings {
  public cellType: string;
  public className: string;
  public contentPadding: string;
  public createdCell: ((
    cell: Node,
    cellData: any,
    rowData: any,
    row: number,
    col: number
  ) => void);
  public data: number | string | DatatableColumnData | ((a: any) => any);
  public defaultContent: string;
  public name: string;
  public orderable: boolean;
  public orderData: number | number[];
  public orderDataType: string;
  public orderFixed: any[] | DatatableOrderFixed;
  public orderSequence: string[];
  public render:
    | number
    | string
    | DatatableColumnData
    | ((data: any, type: any, row: any, meta: CellMetaSettings) => any);
  public searchable: boolean;
  public title: string;
  public type: string;
  public visible: boolean;
  public width: string;
}

class CellMetaSettings implements DataTables.CellMetaSettings {
  public row: number;
  public col: number;
  public settings: DatatableConfiguration;
}
