import DatatableAjax from './datatable-ajax';
import DatatableColumnsSettings from './datatable-columns-settings';

export default class DatatableConfiguration implements DataTables.Settings {
  // public ajax:
  //   | object
  //   | ((data: object, callback: Function, settings: any) => void)
  //   | string = {};
  // public columns: DatatableColumns[] = [];
  // public buttons: DatatableButtons | any[] | boolean = [];
  // public responsive: boolean | DatatableResponsive = true;

  public ajax:
    | string
    | DatatableAjax
    | ((data: object, callback: ((data: any) => void), settings: any) => void);

  public columns: DatatableColumnsSettings[];

  constructor(
    ajax?:
      | string
      | DatatableAjax
      | ((
          data: object,
          callback: ((data: any) => void),
          settings: any
        ) => void),
    columns?: DatatableColumnsSettings[]
  ) {
    this.ajax = ajax;
    this.columns = columns;
  }
  // constructor(
  //   ajax?:
  //     | object
  //     | ((data: object, callback: Function, settings: any) => void)
  //     | string,
  //   columns?: DatatableColumns[],
  //   buttons?: DatatableButtons | any[] | boolean,
  //   responsive?: boolean | DatatableResponsive
  // ) {
  //   this.ajax = ajax;
  //   this.columns = columns;
  //   this.buttons = buttons;
  //   this.responsive = responsive;
  // }

  // public applyConfiguration(
  //   ajax?:
  //     | object
  //     | ((data: object, callback: Function, settings: any) => void)
  //     | string,
  //   columns?: DatatableColumns[],
  //   buttons?: DatatableButtons | any[] | boolean,
  //   responsive?: boolean | DatatableResponsive
  // ): void {
  //   this.ajax = ajax;
  //   this.columns = columns;
  //   this.buttons = buttons;
  //   this.responsive = responsive;
  // }
}
